* PROGRAM VERIFY.PRG
* PROGRAMMER D. ALLEN
* CREATED JUL 18, 2008
* UPDATED JUL 19, 2008
* COPYRIGHT(C) 2008
*
*    THE PURPOSE OF THIS PROGRAM IS TO VERIFY HYPERLINKS AND JPEG IMAGES IN A GIVEN GED FILE.
*
PARAMETERS bSKIP

IF .NOT. bSKIP

  cFILE = GETFILE("GED")
  IF EMPTY(cFILE) .OR. LASTKEY() = 27
    RETURN
  ENDIF

  CLOSE DATABASES
  ERASE ("VERIFY.DBF")
  CREATE DBF ("VERIFY") (http C(180), flag C(1))
  USE VERIFY EXCLUSIVE
  INDEX ON UPPER(http) TAG http

  nFILE = FOPEN(cFILE)
  cREC = ""

  bESC = .F.
  ON ESCAPE bESC =.T.
  SET ESCAPE ON
  DO WHILE nFILE > 0 .AND. .NOT. FEOF(nFILE) .AND. .NOT. bESC
    cD = FGETS(nFILE)
    bCONC = .F.
    DO WHILE nFILE > 0 .AND. .NOT. FEOF(nFILE) .AND. " CONC " $ cD .AND. .NOT. bESC
      bCONC = .T.
      nD = AT(" CONC ", cD)
      cREC = cREC + SUBSTR(cD,nD+6)
      cD = FGETS(nFILE) && don't care about last CONC record
      LOOP
    ENDDO
    IF .NOT. bCONC
      cREC = cD
    ENDIF

    DO WHILE "HTTP://" $ UPPER(cREC) .AND. .NOT. bESC
      nA = AT("HTTP://", UPPER(cREC))
      cREC = SUBSTR(cREC, nA+7)
      cVER = ""
      nA = 1
      DO WHILE nA < LEN(cREC)-3
        DO CASE
        CASE SUBSTR(cREC, nA, 4) = ".jpg"
          cVER = "http://" + LEFT(cREC, nA+3)
          EXIT
        CASE SUBSTR(cREC, nA, 4) = ".txt"
          cVER = "http://" + LEFT(cREC, nA+3)
          EXIT
        CASE SUBSTR(cREC, nA, 5) = ".html"
          cVER = "http://" + LEFT(cREC, nA+4)
          EXIT
        CASE SUBSTR(cREC, nA, 4) = ".htm"
          cVER = "http://" + LEFT(cREC, nA+3)
          EXIT
        ENDCASE
        nA = nA + 1
      ENDDO
      IF EMPTY(cVER) .OR. "whitehouse.gov" $ cVER
        LOOP
      ENDIF

      SELECT VERIFY
      SET EXACT ON
      SEEK PADR(UPPER(cVER),180)
      IF .NOT. FOUND()
        APPEND BLANK
        REPLACE http WITH cVER
      ENDIF
    ENDDO
  ENDDO
  IF nFILE > 0
    = FCLOSE(nFILE)
  ENDIF
  SET ESCAPE OFF
  ON ESCAPE
  && WAIT "press anything to verify, [Esc] to abort" WINDOW TIMEOUT 10
  && IF LASTKEY() = 27
  &&   RETURN
  && ENDIF
ENDIF

bESC = .F.
ON ESCAPE bESC =.T.
SET ESCAPE ON

CLOSE DATABASES
USE VERIFY EXCLUSIVE ALIAS VERIFY
SET FILTER TO EMPTY(flag)
SET ORDER TO 1
GO TOP
DO WHILE .NOT. EOF() .AND. .NOT. bESC
  IF EMPTY(flag)
    nVER = fnVERIFY(ALLTRIM(http))
    IF nVER <> -1
      REPLACE flag WITH IIF(nVER = 200, "V", IIF(bSKIP, "x", "X"))
    ENDIF
  ENDIF
  SKIP
ENDDO
SET ESCAPE OFF
ON ESCAPE

ON KEY LABEL F2 LIST TO PRINTER
SET CONSOLE OFF
SELECT VERIFY
SET FILTER TO flag <> "V"
GO TOP
BROWSE TITLE "Press [F2] to Print, [Esc] to exit"
SET CONSOLE ON
ON KEY LABEL F2
RETURN
*
FUNCTION fnVERIFY
parameters cServer

local cERROR, nERROR
cERROR = ON("ERROR")
ON ERROR nERROR = ERROR()
nERROR = 0

WAIT "Verifying: " + cServer WINDOW NOWAIT

local xmlHTTP, ntmp
&& cServer = "http://www.microsoft.com"
xmlhttp = create("Microsoft.XMLHTTP")
xmlhttp.Open("HEAD", cServer, .f. )
&& TRY
&&   xmlhttp.send()
&&   ? "OK"
&& CATCH
&&   ? "Not OK"
&& ENDTRY
IF nERROR = 0
  xmlhttp.send()
ENDIF
ntmp = IIF(nERROR = 0, xmlhttp.status, -1)
release xmlhttp
RETURN ntmp
